// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// ExpressRouteResourceProvider object
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class ExpressRouteServiceProviderInner : Microsoft.Azure.Management.Resource.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the ExpressRouteServiceProviderInner
        /// class.
        /// </summary>
        public ExpressRouteServiceProviderInner() { }

        /// <summary>
        /// Initializes a new instance of the ExpressRouteServiceProviderInner
        /// class.
        /// </summary>
        /// <param name="peeringLocations">Gets or list of peering
        /// locations</param>
        /// <param name="bandwidthsOffered">Gets or bandwidths offered</param>
        /// <param name="provisioningState">Gets provisioning state of the
        /// resource </param>
        public ExpressRouteServiceProviderInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), System.Collections.Generic.IList<string> peeringLocations = default(System.Collections.Generic.IList<string>), System.Collections.Generic.IList<ExpressRouteServiceProviderBandwidthsOffered> bandwidthsOffered = default(System.Collections.Generic.IList<ExpressRouteServiceProviderBandwidthsOffered>), string provisioningState = default(string))
            : base(location, id, name, type, tags)
        {
            PeeringLocations = peeringLocations;
            BandwidthsOffered = bandwidthsOffered;
            ProvisioningState = provisioningState;
        }

        /// <summary>
        /// Gets or list of peering locations
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.peeringLocations")]
        public System.Collections.Generic.IList<string> PeeringLocations { get; set; }

        /// <summary>
        /// Gets or bandwidths offered
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.bandwidthsOffered")]
        public System.Collections.Generic.IList<ExpressRouteServiceProviderBandwidthsOffered> BandwidthsOffered { get; set; }

        /// <summary>
        /// Gets provisioning state of the resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

    }
}
