// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// LoadBalancer resource
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class LoadBalancerInner : Microsoft.Azure.Management.Resource.Fluent.Resource
    {
        /// <summary>
        /// Initializes a new instance of the LoadBalancerInner class.
        /// </summary>
        public LoadBalancerInner() { }

        /// <summary>
        /// Initializes a new instance of the LoadBalancerInner class.
        /// </summary>
        /// <param name="frontendIPConfigurations">Gets or sets frontend IP
        /// addresses of the load balancer</param>
        /// <param name="backendAddressPools">Gets or sets Pools of backend IP
        /// addresseses</param>
        /// <param name="loadBalancingRules">Gets or sets loadbalancing
        /// rules</param>
        /// <param name="probes">Gets or sets list of Load balancer
        /// probes</param>
        /// <param name="inboundNatRules">Gets or sets list of inbound
        /// rules</param>
        /// <param name="inboundNatPools">Gets or sets inbound NAT
        /// pools</param>
        /// <param name="outboundNatRules">Gets or sets outbound NAT
        /// rules</param>
        /// <param name="resourceGuid">Gets or sets resource guid property of
        /// the Load balancer resource</param>
        /// <param name="provisioningState">Gets provisioning state of the
        /// PublicIP resource Updating/Deleting/Failed</param>
        /// <param name="etag">Gets a unique read-only string that changes
        /// whenever the resource is updated</param>
        public LoadBalancerInner(string location = default(string), string id = default(string), string name = default(string), string type = default(string), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), System.Collections.Generic.IList<FrontendIPConfigurationInner> frontendIPConfigurations = default(System.Collections.Generic.IList<FrontendIPConfigurationInner>), System.Collections.Generic.IList<BackendAddressPoolInner> backendAddressPools = default(System.Collections.Generic.IList<BackendAddressPoolInner>), System.Collections.Generic.IList<LoadBalancingRuleInner> loadBalancingRules = default(System.Collections.Generic.IList<LoadBalancingRuleInner>), System.Collections.Generic.IList<ProbeInner> probes = default(System.Collections.Generic.IList<ProbeInner>), System.Collections.Generic.IList<InboundNatRuleInner> inboundNatRules = default(System.Collections.Generic.IList<InboundNatRuleInner>), System.Collections.Generic.IList<InboundNatPoolInner> inboundNatPools = default(System.Collections.Generic.IList<InboundNatPoolInner>), System.Collections.Generic.IList<OutboundNatRuleInner> outboundNatRules = default(System.Collections.Generic.IList<OutboundNatRuleInner>), string resourceGuid = default(string), string provisioningState = default(string), string etag = default(string))
            : base(location, id, name, type, tags)
        {
            FrontendIPConfigurations = frontendIPConfigurations;
            BackendAddressPools = backendAddressPools;
            LoadBalancingRules = loadBalancingRules;
            Probes = probes;
            InboundNatRules = inboundNatRules;
            InboundNatPools = inboundNatPools;
            OutboundNatRules = outboundNatRules;
            ResourceGuid = resourceGuid;
            ProvisioningState = provisioningState;
            Etag = etag;
        }

        /// <summary>
        /// Gets or sets frontend IP addresses of the load balancer
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.frontendIPConfigurations")]
        public System.Collections.Generic.IList<FrontendIPConfigurationInner> FrontendIPConfigurations { get; set; }

        /// <summary>
        /// Gets or sets Pools of backend IP addresseses
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.backendAddressPools")]
        public System.Collections.Generic.IList<BackendAddressPoolInner> BackendAddressPools { get; set; }

        /// <summary>
        /// Gets or sets loadbalancing rules
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.loadBalancingRules")]
        public System.Collections.Generic.IList<LoadBalancingRuleInner> LoadBalancingRules { get; set; }

        /// <summary>
        /// Gets or sets list of Load balancer probes
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.probes")]
        public System.Collections.Generic.IList<ProbeInner> Probes { get; set; }

        /// <summary>
        /// Gets or sets list of inbound rules
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.inboundNatRules")]
        public System.Collections.Generic.IList<InboundNatRuleInner> InboundNatRules { get; set; }

        /// <summary>
        /// Gets or sets inbound NAT pools
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.inboundNatPools")]
        public System.Collections.Generic.IList<InboundNatPoolInner> InboundNatPools { get; set; }

        /// <summary>
        /// Gets or sets outbound NAT rules
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.outboundNatRules")]
        public System.Collections.Generic.IList<OutboundNatRuleInner> OutboundNatRules { get; set; }

        /// <summary>
        /// Gets or sets resource guid property of the Load balancer resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.resourceGuid")]
        public string ResourceGuid { get; set; }

        /// <summary>
        /// Gets provisioning state of the PublicIP resource
        /// Updating/Deleting/Failed
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets a unique read-only string that changes whenever the resource
        /// is updated
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

    }
}
