// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// VpnClientConfiguration for P2S client
    /// </summary>
    public partial class VpnClientConfiguration
    {
        /// <summary>
        /// Initializes a new instance of the VpnClientConfiguration class.
        /// </summary>
        public VpnClientConfiguration() { }

        /// <summary>
        /// Initializes a new instance of the VpnClientConfiguration class.
        /// </summary>
        /// <param name="vpnClientAddressPool">Gets or sets the reference of
        /// the Address space resource which represents Address space for P2S
        /// VpnClient.</param>
        /// <param name="vpnClientRootCertificates">VpnClientRootCertificate
        /// for Virtual network gateway.</param>
        /// <param
        /// name="vpnClientRevokedCertificates">VpnClientRevokedCertificate
        /// for Virtual network gateway.</param>
        public VpnClientConfiguration(AddressSpace vpnClientAddressPool = default(AddressSpace), System.Collections.Generic.IList<VpnClientRootCertificateInner> vpnClientRootCertificates = default(System.Collections.Generic.IList<VpnClientRootCertificateInner>), System.Collections.Generic.IList<VpnClientRevokedCertificateInner> vpnClientRevokedCertificates = default(System.Collections.Generic.IList<VpnClientRevokedCertificateInner>))
        {
            VpnClientAddressPool = vpnClientAddressPool;
            VpnClientRootCertificates = vpnClientRootCertificates;
            VpnClientRevokedCertificates = vpnClientRevokedCertificates;
        }

        /// <summary>
        /// Gets or sets the reference of the Address space resource which
        /// represents Address space for P2S VpnClient.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "vpnClientAddressPool")]
        public AddressSpace VpnClientAddressPool { get; set; }

        /// <summary>
        /// Gets or sets vpnClientRootCertificate for Virtual network gateway.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "vpnClientRootCertificates")]
        public System.Collections.Generic.IList<VpnClientRootCertificateInner> VpnClientRootCertificates { get; set; }

        /// <summary>
        /// Gets or sets vpnClientRevokedCertificate for Virtual network
        /// gateway.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "vpnClientRevokedCertificates")]
        public System.Collections.Generic.IList<VpnClientRevokedCertificateInner> VpnClientRevokedCertificates { get; set; }

    }
}
