// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Storage.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// The parameters to provide for the account.
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class StorageAccountUpdateParametersInner
    {
        /// <summary>
        /// Initializes a new instance of the
        /// StorageAccountUpdateParametersInner class.
        /// </summary>
        public StorageAccountUpdateParametersInner()
        {
        }

        /// <summary>
        /// Initializes a new instance of the
        /// StorageAccountUpdateParametersInner class.
        /// </summary>
        /// <param name="sku">Gets or sets the sku type. Note that sku cannot
        /// be updated to StandardZRS or ProvisionedLRS, nor can accounts of
        /// that sku type be updated to any other value.</param>
        /// <param name="tags">Gets or sets a list of key value pairs that
        /// describe the resource. These tags can be used in viewing and
        /// grouping this resource (across resource groups). A maximum of 15
        /// tags can be provided for a resource. Each tag must have a key no
        /// greater than 128 characters and value no greater than 256
        /// characters.</param>
        /// <param name="customDomain">User domain assigned to the storage
        /// account. Name is the CNAME source. Only one custom domain is
        /// supported per storage account at this time. To clear the existing
        /// custom domain, use an empty string for the custom domain name
        /// property.</param>
        /// <param name="encryption">Provides the encryption settings on the
        /// account. The default setting is unencrypted.</param>
        /// <param name="accessTier">The access tier used for billing. Access
        /// tier cannot be changed more than once every 7 days (168 hours).
        /// Access tier cannot be set for StandardLRS, StandardGRS,
        /// StandardRAGRS, or PremiumLRS account types. Possible values
        /// include: 'Hot', 'Cool'</param>
        public StorageAccountUpdateParametersInner(Sku sku = default(Sku), System.Collections.Generic.IDictionary<string, string> tags = default(System.Collections.Generic.IDictionary<string, string>), CustomDomain customDomain = default(CustomDomain), Encryption encryption = default(Encryption), AccessTier? accessTier = default(AccessTier?))
        {
            Sku = sku;
            Tags = tags;
            CustomDomain = customDomain;
            Encryption = encryption;
            AccessTier = accessTier;
        }

        /// <summary>
        /// Gets or sets the sku type. Note that sku cannot be updated to
        /// StandardZRS or ProvisionedLRS, nor can accounts of that sku type
        /// be updated to any other value.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "sku")]
        public Sku Sku { get; set; }

        /// <summary>
        /// Gets or sets a list of key value pairs that describe the resource.
        /// These tags can be used in viewing and grouping this resource
        /// (across resource groups). A maximum of 15 tags can be provided
        /// for a resource. Each tag must have a key no greater than 128
        /// characters and value no greater than 256 characters.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "tags")]
        public System.Collections.Generic.IDictionary<string, string> Tags { get; set; }

        /// <summary>
        /// Gets or sets user domain assigned to the storage account. Name is
        /// the CNAME source. Only one custom domain is supported per storage
        /// account at this time. To clear the existing custom domain, use an
        /// empty string for the custom domain name property.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.customDomain")]
        public CustomDomain CustomDomain { get; set; }

        /// <summary>
        /// Gets or sets provides the encryption settings on the account. The
        /// default setting is unencrypted.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.encryption")]
        public Encryption Encryption { get; set; }

        /// <summary>
        /// Gets or sets the access tier used for billing. Access tier cannot
        /// be changed more than once every 7 days (168 hours). Access tier
        /// cannot be set for StandardLRS, StandardGRS, StandardRAGRS, or
        /// PremiumLRS account types. Possible values include: 'Hot', 'Cool'
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.accessTier")]
        public AccessTier? AccessTier { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (this.Sku != null)
            {
                this.Sku.Validate();
            }
            if (this.CustomDomain != null)
            {
                this.CustomDomain.Validate();
            }
        }
    }
}
